\documentclass{article}
\usepackage{amsmath}
\usepackage{graphicx}
\begin{document}
	~\
	
	(b) step 1: pick $y_{AE}$ and set $y_{AE} = 20$ such that the constraint on $A$ is tight. Add $A$ to $S$ and freeze $y_{AE}$.
	
	step 2: pick $y_{BE}$ and set $y_{BE} = 10$ such that the constraint on $B$ is tight. Add $B$ to $S$ and freeze $y_{BE}$.
		
	step 3: pick $y_{DE}$ and set $y_{DE} = 70$ such that the constraint on $D$ is tight. Add $D$ to $S$ and freeze $y_{DE}$. Also, the constraint on $E$ is tight. Add $E$ to $S$ and freeze $y_{CE}$.
	
	step 4: all edges are frozen, the algorithm ends.
	
	~\
	
	(c) The algorithm isn't still able to pick vertices $A, B, D$ and $E$. Before all the constraints on $A, B, D$ are tight, the constraint on $E$ is tight and then the algorithm freezes all edges and it ends. 
	
	~\
	
	(d) (i) First, prove that the set $S$ is a vertex cover. Use proof of contradiction. Suppose that there is an edge $\{u, v\}$ isn't covered. We can conclude that the constraints on both $u$ and $v$ are not tight. Thus, the edge $\{u, v\}$ is not frozen and the algorithm should continue. There is a contradiction.
	
	(ii) Second, prove that the algorithm is a 2-approximation algorithm. Suppose $y_e^{'}$ is a feasible solution for $D_{WMVC}$ and $OPT$ is the optimal solution to $WMVC$. According to the weak duality theorem, $\sum_{e \in E} y_e^{'} \leq OPT$. Then we calculate the cost of $S$: 
	$$\sum_{v \in S} w(v) = \sum_{e \text{ is incident on } v, v \in S} y_e^{'}$$ 
	Since edges incident on $v$, $v \in S$ can cover at most 2 times of all edges,
	$$\sum_{v \in S} w(v) = \sum_{e \text{ is incident on } v, v \in S} y_e^{'} \leq 2 \cdot \sum_{e \in E} y_e^{'} \leq 2 \cdot OPT$$ 
	Thus, the algorithm is a 2-approximation algorithm.
\end{document}

